ClarisWksStruct::DSET Struct Reference documentation

ClarisWksStruct::DSET Struct Reference

main structure which correspond to a document part More...

`#include <ClarisWksStruct.hxx>`

Inheritance diagram for ClarisWksStruct::DSET:

## Classes
struct | Child
| structure used to define the child of a DSET structure More...

## Public Types
enum | Position { P_Main =0 , P_Header , P_Footer , P_Frame , P_Footnote , P_Table , P_GraphicMaster , P_Slide , P_SlideNote , P_SlideThumbnail , P_SlideMaster , P_Unknown }
| the zone position More...
enum | ChildType { C_Zone , C_SubText , C_Graphic , C_Unknown }
| the different types of zone child More...

## Public Member Functions
| DSET ()
| constructor
| DSET (DSET const &)=default
virtual | ~DSET ()
| virtual destructor
bool | isHeaderFooter () const
| test if the zone is an header/footer
bool | isSlide () const
| test if the zone is a slide
MWAWBox2f | getBdBox () const
| return the zone bdbox
int | getMaximumPage () const
| returns the maximum page
virtual void | removeChild (int cId, bool normalChild)
| virtual function to remove a child from a list
virtual void | removeChild (int cId)
| virtual function to remove a child from a list
void | updateChildPositions (MWAWVec2f const &pageDim, float formLength, int numHorizontalPages=1)
| try to update the child page and bounding box
void | findForbiddenPagesBreaking (float pageDim, float formDim, int dim, MWAWVariable< int > &lastPage) const
| find forbidden page break
MWAWBox2i | getUnionChildBox () const
| returns the child box (ie. the union of the childs box)

## Public Attributes
long | m_size
| the size of the DSET header
long | m_numData
| the number of header
long | m_dataSz
| the data size
long | m_headerSz
| the header size
Position | m_position
| the zone type
int | m_fileType
| the type ( 0: text, -1: graphic, ...)
int | m_page
| the page (if known)
MWAWBox2f | m_box
| the bounding box (if known)
MWAWVec2f | m_pageDimension
| the page dimension (if know)
int | m_id
| the zone identificator
std::set< int > | m_fathersList
| the list of fathers
int | m_beginSelection
| the begin of selection ( at least in text header)
int | m_endSelection
| the end of selection ( at least in text header)
int | m_textType
| the text type (header/footer,footnote, ...)
int | m_flags [4]
| some unknown flag
std::vector< Child > | m_childs
| the list of child zone
std::vector< int > | m_otherChilds
| the list of other child
bool | m_parsed
| a flag to know if the entry is sent or not to the listener
int | m_internal
| an internal variable used to do some computation

## Friends
std::ostream & | operator<< (std::ostream &o, DSET const &doc)
| operator<<

## Detailed Description

main structure which correspond to a document part

## Member Enumeration Documentation

## ◆ ChildType

enum ClarisWksStruct::DSET::ChildType

the different types of zone child

Enumerator
C_Zone |
C_SubText |
C_Graphic |
C_Unknown |

## ◆ Position

enum ClarisWksStruct::DSET::Position

the zone position

Enumerator
P_Main |
P_Header |
P_Footer |
P_Frame |
P_Footnote |
P_Table |
P_GraphicMaster |
P_Slide |
P_SlideNote |
P_SlideThumbnail |
P_SlideMaster |
P_Unknown |

## Constructor & Destructor Documentation

## ◆ DSET() [1/2]

ClarisWksStruct::DSET::DSET | ( |  | ) |
| inline

constructor

Referenced by ClarisDrawGraphInternal::Bitmap::Bitmap(), ClarisWksGraphInternal::Bitmap::Bitmap(), ClarisWksDatabaseInternal::Database::Database(), DSET(), ClarisDrawGraphInternal::Group::Group(), ClarisWksGraphInternal::Group::Group(), operator<<, ClarisWksPresentationInternal::Presentation::Presentation(), ClarisWksSpreadsheetInternal::Spreadsheet::Spreadsheet(), ClarisWksTableInternal::Table::Table(), and ClarisWksTextInternal::Zone::Zone().

## ◆ DSET() [2/2]

ClarisWksStruct::DSET::DSET | ( | DSET const & |  | ) |
| default

## ◆ ~DSET()

virtual ClarisWksStruct::DSET::~DSET | ( |  | ) |
| inlinevirtual

virtual destructor

Reimplemented in ClarisDrawTextInternal::DSET.

## Member Function Documentation

## ◆ findForbiddenPagesBreaking()

void ClarisWksStruct::DSET::findForbiddenPagesBreaking | ( | float | pageDim,
|  | float | formDim,
|  | int | dim,
|  | MWAWVariable< int > & | lastPage ) const

find forbidden page break

## ◆ getBdBox()

MWAWBox2f ClarisWksStruct::DSET::getBdBox | ( |  | ) | const
| inline

return the zone bdbox

## ◆ getMaximumPage()

int ClarisWksStruct::DSET::getMaximumPage | ( |  | ) | const
| inline

returns the maximum page

## ◆ getUnionChildBox()

MWAWBox2i ClarisWksStruct::DSET::getUnionChildBox | ( |  | ) | const

returns the child box (ie. the union of the childs box)

## ◆ isHeaderFooter()

bool ClarisWksStruct::DSET::isHeaderFooter | ( |  | ) | const
| inline

test if the zone is an header/footer

Referenced by findForbiddenPagesBreaking(), and ClarisWksGraph::updateGroup().

## ◆ isSlide()

bool ClarisWksStruct::DSET::isSlide | ( |  | ) | const
| inline

test if the zone is a slide

Referenced by ClarisWksGraph::sendGroup().

## ◆ removeChild() [1/2]

void ClarisWksStruct::DSET::removeChild | ( | int | cId | ) |
| virtual

virtual function to remove a child from a list

## ◆ removeChild() [2/2]

void ClarisWksStruct::DSET::removeChild | ( | int | cId,
|  | bool | normalChild )
| virtual

virtual function to remove a child from a list

Reimplemented in ClarisDrawGraphInternal::Group, ClarisWksGraphInternal::Group, ClarisWksPresentationInternal::Presentation, ClarisWksTableInternal::Table, and ClarisWksTextInternal::Zone.

Referenced by removeChild().

## ◆ updateChildPositions()

void ClarisWksStruct::DSET::updateChildPositions | ( | MWAWVec2f const & | pageDim,
|  | float | formLength,
|  | int | numHorizontalPages = 1 )

try to update the child page and bounding box

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | o,
|  | DSET const & | doc )
| friend

operator<<

## Member Data Documentation

## ◆ m_beginSelection

int ClarisWksStruct::DSET::m_beginSelection

the begin of selection ( at least in text header)

Referenced by DSET(), operator<<, ClarisDrawParser::readDSET(), and ClarisWksDocument::readDSET().

## ◆ m_box

MWAWBox2f ClarisWksStruct::DSET::m_box

the bounding box (if known)

Referenced by DSET(), getBdBox(), operator<<, ClarisWksGraph::sendGroup(), and updateChildPositions().

## ◆ m_childs

std::vector<Child> ClarisWksStruct::DSET::m_childs

the list of child zone

Referenced by DSET(), findForbiddenPagesBreaking(), getMaximumPage(), getUnionChildBox(), operator<<, removeChild(), updateChildPositions(), and ClarisWksGraph::updateGroup().

## ◆ m_dataSz

long ClarisWksStruct::DSET::m_dataSz

the data size

Referenced by DSET(), operator<<, ClarisDrawGraph::readBitmapZone(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisDrawParser::readDSET(), ClarisWksDocument::readDSET(), ClarisDrawGraph::readGroupZone(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

## ◆ m_endSelection

int ClarisWksStruct::DSET::m_endSelection

the end of selection ( at least in text header)

Referenced by DSET(), operator<<, ClarisDrawParser::readDSET(), and ClarisWksDocument::readDSET().

## ◆ m_fathersList

std::set<int> ClarisWksStruct::DSET::m_fathersList

the list of fathers

Referenced by DSET(), and operator<<.

## ◆ m_fileType

int ClarisWksStruct::DSET::m_fileType

the type ( 0: text, -1: graphic, ...)

Referenced by DSET(), operator<<, ClarisDrawGraph::readBitmapZone(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisDrawParser::readDSET(), ClarisWksDocument::readDSET(), ClarisDrawText::readDSETZone(), ClarisWksText::readDSETZone(), ClarisDrawGraph::readGroupZone(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

## ◆ m_flags

int ClarisWksStruct::DSET::m_flags[4]

some unknown flag

Referenced by DSET(), ClarisDrawTextInternal::DSET::isOutlined(), operator<<, ClarisDrawParser::readDSET(), and ClarisWksDocument::readDSET().

## ◆ m_headerSz

long ClarisWksStruct::DSET::m_headerSz

the header size

Referenced by DSET(), operator<<, ClarisDrawGraph::readBitmapZone(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisDrawParser::readDSET(), ClarisWksDocument::readDSET(), ClarisDrawGraph::readGroupZone(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

## ◆ m_id

int ClarisWksStruct::DSET::m_id

the zone identificator

Referenced by DSET(), operator<<, ClarisDrawParser::readDSET(), ClarisWksDocument::readDSET(), ClarisDrawText::readDSETZone(), ClarisWksText::readDSETZone(), ClarisWksPresentationInternal::Presentation::removeChild(), ClarisWksTableInternal::Table::removeChild(), ClarisWksGraph::sendGroup(), and ClarisWksText::sendText().

## ◆ m_internal

int ClarisWksStruct::DSET::m_internal
| mutable

an internal variable used to do some computation

Referenced by DSET().

## ◆ m_numData

long ClarisWksStruct::DSET::m_numData

the number of header

Referenced by DSET(), operator<<, ClarisDrawGraph::readBitmapZone(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisDrawParser::readDSET(), ClarisWksDocument::readDSET(), ClarisDrawText::readDSETZone(), ClarisWksText::readDSETZone(), ClarisDrawGraph::readGroupZone(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

## ◆ m_otherChilds

std::vector<int> ClarisWksStruct::DSET::m_otherChilds

the list of other child

Referenced by DSET(), operator<<, ClarisWksDatabase::readLayout(), ClarisWksTable::readTableCells(), ClarisWksText::readTextSection(), ClarisWksPresentation::readZone1(), removeChild(), and removeChild().

## ◆ m_page

int ClarisWksStruct::DSET::m_page

the page (if known)

Referenced by ClarisWksGraph::canSendAsGraphic(), DSET(), getMaximumPage(), ClarisDrawGraphInternal::Group::Group(), ClarisWksGraphInternal::Group::Group(), operator<<, ClarisWksGraph::sendGroup(), and updateChildPositions().

## ◆ m_pageDimension

MWAWVec2f ClarisWksStruct::DSET::m_pageDimension

the page dimension (if know)

Referenced by DSET(), findForbiddenPagesBreaking(), operator<<, ClarisDrawGraph::readGroupUnknown(), ClarisWksGraph::readGroupUnknown(), and updateChildPositions().

## ◆ m_parsed

bool ClarisWksStruct::DSET::m_parsed
| mutable

a flag to know if the entry is sent or not to the listener

Referenced by DSET(), ClarisDrawGraph::sendBitmap(), ClarisWksGraph::sendBitmap(), ClarisWksGraph::sendGroup(), ClarisWksGraph::sendPageChild(), ClarisDrawText::sendText(), and ClarisWksText::sendText().

## ◆ m_position

Position ClarisWksStruct::DSET::m_position

the zone type

Referenced by ClarisWksGraph::canSendAsGraphic(), DSET(), findForbiddenPagesBreaking(), getMaximumPage(), isHeaderFooter(), isSlide(), operator<<, ClarisWksGraph::sendGroup(), updateChildPositions(), and ClarisWksGraph::updateGroup().

## ◆ m_size

long ClarisWksStruct::DSET::m_size

the size of the DSET header

Referenced by DSET(), ClarisDrawParser::readDSET(), and ClarisWksDocument::readDSET().

## ◆ m_textType

int ClarisWksStruct::DSET::m_textType

the text type (header/footer,footnote, ...)

Referenced by DSET(), operator<<, ClarisDrawParser::readDSET(), and ClarisWksDocument::readDSET().

The documentation for this struct was generated from the following files:

- ClarisWksStruct.hxx
- ClarisWksStruct.cxx